import { ElementRef, EventEmitter, OnDestroy, OnInit, Renderer2 } from '@angular/core';
import { Overlay, OverlayPositionBuilder } from '@angular/cdk/overlay';
import { MdbTooltipPosition } from './tooltip.types';
import { Subject } from 'rxjs';
export declare class MdbTooltipDirective implements OnInit, OnDestroy {
    private _overlay;
    private _overlayPositionBuilder;
    private _elementRef;
    private _renderer;
    mdbTooltip: string;
    tooltipDisabled: boolean;
    placement: MdbTooltipPosition;
    html: boolean;
    animation: boolean;
    trigger: string;
    delayShow: number;
    delayHide: number;
    offset: number;
    tooltipShow: EventEmitter<MdbTooltipDirective>;
    tooltipShown: EventEmitter<MdbTooltipDirective>;
    tooltipHide: EventEmitter<MdbTooltipDirective>;
    tooltipHidden: EventEmitter<MdbTooltipDirective>;
    private _overlayRef;
    private _tooltipRef;
    private _open;
    private _showTimeout;
    private _hideTimeout;
    readonly _destroy$: Subject<void>;
    constructor(_overlay: Overlay, _overlayPositionBuilder: OverlayPositionBuilder, _elementRef: ElementRef, _renderer: Renderer2);
    ngOnInit(): void;
    ngOnDestroy(): void;
    private _bindTriggerEvents;
    private _createOverlayConfig;
    private _createOverlay;
    private _getPosition;
    show(): void;
    hide(): void;
    toggle(): void;
}
